Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1987965

Summary: rust-clap: FTBFS in Fedora rawhide/f35
Product: [Fedora] Fedora Reporter: Fedora Release Engineering <releng>
Component: rust-clapAssignee: Rust SIG <rust-sig>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 35CC: decathorpe, igor.raits, jistone, rust-sig, tstellar
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: rust-clap-3.0.0~beta.5-2.fc36 rust-clap-3.0.0~beta.5-2.fc35 rust-clap-3.0.0~beta.5-2.fc34 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-11-21 17:48:11 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1927309, 1992484    
Attachments:
Description Flags
build.log
none
root.log
none
state.log none

Description Fedora Release Engineering 2021-07-29 17:06:08 UTC
rust-clap failed to build from source in Fedora rawhide/f35

https://koji.fedoraproject.org/koji/taskinfo?taskID=72496009


For details on the mass rebuild see:

https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild
Please fix rust-clap at your earliest convenience and set the bug's status to
ASSIGNED when you start fixing it. If the bug remains in NEW state for 8 weeks,
rust-clap will be orphaned. Before branching of Fedora 36,
rust-clap will be retired, if it still fails to build.

For more details on the FTBFS policy, please visit:
https://docs.fedoraproject.org/en-US/fesco/Fails_to_build_from_source_Fails_to_install/

Comment 1 Fedora Release Engineering 2021-07-29 17:06:13 UTC
Created attachment 1808723 [details]
build.log

file build.log too big, will only attach last 32768 bytes

Comment 2 Fedora Release Engineering 2021-07-29 17:06:16 UTC
Created attachment 1808724 [details]
root.log

file root.log too big, will only attach last 32768 bytes

Comment 3 Fedora Release Engineering 2021-07-29 17:06:18 UTC
Created attachment 1808725 [details]
state.log

Comment 4 Fabio Valentini 2021-07-30 09:18:10 UTC
This seems to be caused by either an LLVM or Rust bug that is encountered when compiling a massive number of doctests in parallel on i686:

error: ran out of registers during register allocation
LLVM ERROR: Cannot emit physreg copy instruction
Couldn't compile the test.

Comment 5 Josh Stone 2021-07-30 18:38:40 UTC
I would call that an LLVM bug first, unless we find something specific that Rust is doing wrong.

Comment 6 Fabio Valentini 2021-07-30 19:47:33 UTC
Do you know if there's a way to limit parallelism for building doctests?
It seems like rustdoc does not limit the number of compile tasks it launches in parallel at all, which might contribute to this issue.

Comment 7 Josh Stone 2021-07-30 21:53:18 UTC
The parallelism should default to the number of logical cpus, but you can set RUST_TEST_THREADS=1 (or any number).

Comment 8 Ben Cotton 2021-08-10 13:30:14 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 35 development cycle.
Changing version to 35.

Comment 9 Fabio Valentini 2021-08-11 13:10:58 UTC
Ok ... I ran a scratch build with RUST_TEST_THREADS=1, and the i686 issue is still the same:
https://koji.fedoraproject.org/koji/taskinfo?taskID=73671680

---- src/build/arg_group.rs - build::arg_group::ArgGroup::arg (line 119) stdout ----
error: ran out of registers during register allocation
LLVM ERROR: Cannot emit physreg copy instruction
Couldn't compile the test.

Not sure how LLVM would ever run out of registers during code generation ...

Comment 10 Fedora Update System 2021-11-21 17:48:11 UTC
FEDORA-2021-d30f9d81fe has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 11 Fedora Update System 2021-11-21 17:50:48 UTC
FEDORA-2021-1937205ae5 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-1937205ae5

Comment 12 Fedora Update System 2021-11-21 17:55:05 UTC
FEDORA-2021-b9e6038b3b has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-b9e6038b3b

Comment 13 Fedora Update System 2021-11-22 02:26:49 UTC
FEDORA-2021-1937205ae5 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-1937205ae5`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-1937205ae5

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2021-11-22 02:32:13 UTC
FEDORA-2021-b9e6038b3b has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-b9e6038b3b`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-b9e6038b3b

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2021-11-24 09:13:58 UTC
FEDORA-2021-b9e6038b3b has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-b9e6038b3b

Comment 16 Fedora Update System 2021-11-24 09:57:43 UTC
FEDORA-2021-1937205ae5 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-1937205ae5

Comment 17 Fedora Update System 2021-11-25 23:15:58 UTC
FEDORA-2021-b9e6038b3b has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-b9e6038b3b

Comment 18 Fedora Update System 2021-11-26 02:15:26 UTC
FEDORA-2021-1937205ae5 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-1937205ae5

Comment 19 Fedora Update System 2021-11-26 03:04:22 UTC
FEDORA-2021-b9e6038b3b has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-b9e6038b3b`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-b9e6038b3b

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 20 Fedora Update System 2021-11-26 03:12:42 UTC
FEDORA-2021-1937205ae5 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-1937205ae5`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-1937205ae5

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 21 Fedora Update System 2021-11-27 01:10:11 UTC
FEDORA-2021-1937205ae5 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 22 Fedora Update System 2021-11-29 01:11:03 UTC
FEDORA-2021-b9e6038b3b has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.